
class Antitweak extends mutator config(CAC);

//Server vars
var private int zzserverTickCount;
var private canvas can;
var private weapon zzw;
var private SmallWoodFragments zzATLog;

//Vars replicated from server to client
var private bool zzbVarsSet;
var private float zzflagLtRad, zzflagDrawScale;
var private bool zzbWaterInvis, zzbRocketPuffHidden, zzbRocketTrailHidden, zzbUtSmokeTrail;
var private float zzUTSmokeTrailDS, zzShockBeamLifeSpan, zzShockBeamDS, zzPBoltDS, zzstarterBoltDS;
var private mesh zzPBoltMesh, zzStarterBoltMesh, zzshockBeamMesh;
var private texture zzPlasmaHitTexture;
var private byte zzSBEffectLightType, zzenhancedRespawnDrawType, zzEnhancedRespawnLightEffect, zzTransTargetSoundRadius, zzTransTargetLightType, zzTransTargetLightEffect;
var private float zzenhancedRespawnLifeSpan, zzenhancedRespawnLightRadius, zzTransTargetLightRadius, zzTransTargetLightBrightness;
var private bool zzplayerBUnlit;
var private texture zztranseffectTexture;
var private bool zzbFireWetTextureInvis;
var private bool zzbTextureTransparent;
var private float zzSBDS, zzAmpDS, zzDeemerDS, zzKegDS, zzBootsDS, zzArmorDS, zzinvisDS;
var private mesh zzflagMesh, zzsbmesh, zzampmesh, zzdeemermesh, zzkegmesh, zzarmorMesh, zzbootsMesh, zzinvisMesh;

var config bool LogOnly;

//Client vars
var private int zztickCount, zzyTCount;
var private bool zzbGotP, zzbChecked;
var private playerpawn p;
var private bool bJustTossedWeapon;
var private bool bDeathsSent;

replication
{
   reliable if (Role==Role_Authority)
		zzflagLtRad, zzflagDrawScale, zzbWaterInvis, zzSBDS, zzAmpDS, zzDeemerDS, zzKegDS, zzBootsDS, zzArmorDS,
		zzflagMesh, zzsbmesh, zzampmesh, zzdeemermesh, zzkegmesh, zzarmorMesh, zzbootsMesh, zzinvisDS, zzinvisMesh, 
		zzbRocketPuffHidden, zzbRocketTrailHidden, zzbUtSmokeTrail,zzUTSmokeTrailDS, zzShockBeamLifeSpan, zzShockBeamDS, 
		zzPBoltDS, zzstarterBoltDS, zzPBoltMesh, zzStarterBoltMesh, zzPlasmaHitTexture, zzSBEffectLightType,
		zzenhancedRespawnDrawType, zzEnhancedRespawnLightEffect,zzenhancedRespawnLifeSpan, zzenhancedRespawnLightRadius,
		zzplayerBUnlit, zztranseffectTexture, zzbFireWetTextureInvis, zzshockBeamMesh, zzTransTargetSoundRadius, 
		zzTransTargetLightRadius, zzTransTargetLightType, zzTransTargetLightEffect, zzTransTargetLightBrightness, 
		zzbTextureTransparent;
}

function PostBeginPlay()
{
 	Level.Game.RegisterMessageMutator(Self);
   zzATlog = spawn(class'SmallWoodFragments');
   log("*    CombinedAC: AntiTweak is Active                 *");
}

function xxsetVars()
{
   local ut_shieldbelt zzsb;
   local udamage zzamp;
   local warheadlauncher zzdeemer;
   local healthpack zzkeg;
   local ctfflag zzflag;
   local ut_invisibility zzinvis;
   local armor2 zzarmor;
   local ut_jumpboots zzboots;

   foreach allactors(class'ut_shieldBelt', zzsb)
	{
      zzSBDS = zzsb.DrawScale;
      zzsbmesh = zzsb.Mesh;
      break;
   }
   foreach allactors(class'udamage', zzamp)
	{
      zzAmpDS = zzamp.DrawScale;
      zzampmesh = zzamp.Mesh;
      break;
   }
   foreach allactors(class'warheadlauncher', zzdeemer)
	{
      zzDeemerDS = zzdeemer.DrawScale;
      zzdeemermesh = zzdeemer.Mesh;
      break;
   }
   foreach allactors(class'healthPack', zzkeg)
	{
      zzKegDS = zzkeg.DrawScale;
      zzkegmesh = zzkeg.Mesh;
      break;
   }
   foreach allactors(class'ut_invisibility', zzinvis)
	{
      zzinvisDS = zzinvis.DrawScale;
      zzinvisMesh = zzinvis.Mesh;
      break;
   }
   foreach allactors(class'armor2', zzarmor)
	{
      zzArmorDS = zzarmor.DrawScale;
      zzarmorMesh = zzarmor.Mesh;
      break;
   }
   foreach allactors(class'ut_jumpboots', zzboots)
	{
      zzBootsDS = zzboots.DrawScale;
      zzbootsMesh = zzboots.Mesh;
      break;
   }
   foreach allactors(class'ctfflag', zzflag)
	{
      zzflagDrawScale = zzflag.DrawScale;
      zzflagMesh = zzflag.Mesh;
      zzflagLtRad = zzflag.LightRadius;
      break;
   }
    
   zzbRocketPuffHidden = class'ut_spriteSmokePuff'.default.bHidden;
   zzbRocketTrailHidden = class'LightSmokeTrail'.default.bHidden;
   zzbUtSmokeTrail = class'utSmokeTrail'.default.bHidden;
   zzUTSmokeTrailDS = class'utSmokeTrail'.default.drawScale;
   zzbWaterInvis = class'fire.waterTexture'.default.bInvisible;
   zzbFireWetTextureInvis = class'fire.wetTexture'.default.bInvisible;

   zzShockBeamLifeSpan =  class'ShockBeam'.default.lifespan;
   zzShockBeamDS =  class'ShockBeam'.default.drawScale;
   zzshockBeamMesh = class'ShockBeam'.default.mesh;

   zzPBoltDS = class'pbolt'.default.drawScale;
   zzPBoltMesh = class'pbolt'.default.Mesh;
   zzstarterBoltDS = class'starterbolt'.default.drawScale;
   zzStarterBoltMesh = class'starterbolt'.default.mesh;
   zzPlasmaHitTexture = class'plasmaHit'.default.texture;

   zzSBEffectLightType = class'UT_shieldBeltEffect'.default.lightType;

   zzenhancedRespawnDrawType = class'enhancedRespawn'.default.drawType;
   zzenhancedRespawnLifeSpan = class'enhancedRespawn'.default.lifespan;
   zzEnhancedRespawnLightEffect = class'enhancedRespawn'.default.LightEffect;
   zzenhancedRespawnLightRadius = class'enhancedRespawn'.default.lightRadius;

   zztranseffectTexture = class'translocouteffect'.default.texture;

   zzplayerBUnlit = class'tmale1'.default.bunlit;

   zzTransTargetSoundRadius = class'Translocatortarget'.default.soundradius;
   zzTransTargetLightRadius = class'Translocatortarget'.default.lightRadius;
   zzTransTargetLightType = class'Translocatortarget'.default.lightType;
   zzTransTargetLightEffect = class'Translocatortarget'.default.lightEffect;
   zzTransTargetLightBrightness = class'translocatortarget'.default.lightBrightness;

   zzbTextureTransparent = class'texture'.default.bTransparent;
}

static final function string ReplaceText(coerce string Text, coerce string Replace, coerce string With)
{
   local int i;
   local string Output;

   i = InStr(Text, Replace);
   while (i != -1)
	{
      Output = Output $ Left(Text, i) $ With;
      Text = Mid(Text, i + Len(Replace));
      i = InStr(Text, Replace);
   }
   Output = Output $ Text;
   return Output;
}

function xxATLogThis(string str, string serverName)
{
   local string parts[];

   zzATlog.StartLog();
   zzATLog.logEventString("Server Name: " $ serverName);
   zzATlog.logEventString(str);
   zzATlog.stopLog();
}

function Mutate(string MutateStr, playerpawn sender)
{
   local string zztweakstr, address,ip;
   local tournamentplayer tp;
    
	if (left(mutateStr, 9) ~= "AntiCheat")
	{
      if (mid(mutateStr, 10, 9) ~= "broadcast")
		{
         if (level.game.numPlayers >= 1)
			{
            zztweakstr = right(mutateStr, len(mutateStr)-20);
            address = sender.getPlayerNetworkAddress();

				if(!LogOnly)
				{
            	sender.clientmessage("--------------------------------------------------");
            	sender.clientmessage(zztweakstr $ " detected.");
            	sender.clientmessage("Please restart UT and rejoin without the tweak.");
            	sender.clientmessage("--------------------------------------------------");
            	sender.destroy();
            }
                 
            if (address!="") 
					ip=left(address,instr(address,":"));
            else 
					ip="0.0.0.0";

				if(!LogOnly)
            	broadcastmessage(zztweakstr);
            xxATLogThis(zztweakstr $ " (IP Address: " $ ip $ ")", level.game.gameReplicationInfo.serverName);
         }
      }
   }
   if (sender!=none)
		super.mutate(mutatestr,sender);
}

simulated function tick(float Delta)
{
   if (level.netMode!=NM_DedicatedServer && !bHudMutator)
	 	registerHudMutator();
   else
	{
      if (!zzbVarsSet)
		{
         if (zzserverTickCount > 100)
			{ 
				xxsetVars(); 
				zzbVarsSet = true;
			}
         else zzserverTickCount++;
      }
	}
}

simulated event PostRender(canvas c)
{
   if (!zzbGotP)
	{
	   p = c.viewport.actor;
      zzbGotP=true;
   }
   
	if (!zzbChecked)
	{
      if (zztickCount > 300)
		{
         if (p != none)
			{
				xxcheckTweaks();
				setTimer(5,true);
			}
         zzbChecked = true;
      }
      else zztickCount++;
   }
   super.postrender(c);
}


simulated function Timer()
{
   if (zzbVarsSet && p != none)
		xxcheckTweaks();
}

simulated function xxcheckTweaks()
{
  	local string zztweakStr;

   zztweakStr = xxfindTweak();
   if(!LogOnly)
   	if (zztweakStr != "")
     		broadcast("*** AntiCheat Alert *** : " $ p.PlayerReplicationInfo.PlayerName $ " was kicked for: " $ zztweakStr);
}

simulated function string xxfindTweak()
{
   local ut_shieldbelt zzsb;
   local udamage zzamp;
   local warheadlauncher zzdeemer;
   local healthpack zzkeg;
   local ctfflag zzflag;
   local ut_invisibility zzinvis;
   local armor2 zzarmor;
   local ut_jumpboots zzboots;
   local playerpawn zzaplayer;

   if (class'texture'.default.bTransparent != zzbTextureTransparent)
		return "Wall Hack (Transparent Walls)";
        
   foreach p.level.allactors(class'ut_shieldBelt', zzsb)
	{
      if (zzsb.drawscale > zzSBDS && zzSBDS != 0) 
			return "Big SB Tweak" $ " (Details: Server's=" $ zzSBDS $ " , Player's=" $ zzSB.drawScale $ ")";
      else if (zzsb.Mesh != zzsbmesh && zzsb.Mesh != none && zzsbmesh != none)
			return "Altered SB Mesh Tweak" $ " (Details: Server's=" $ zzsbmesh $ " , Player's=" $ zzSB.Mesh $ ")";
   }
   foreach p.level.allactors(class'udamage', zzamp)
	{
      if (zzamp.drawscale > zzAmpDS && zzAmpDS != 0)
		  	return "Big Amp Tweak" $ " (Details: Server's=" $ zzAmpDS $ " , Player's=" $ zzAmp.drawScale $ ")";
      else if (zzamp.Mesh != zzampmesh && zzAmp.Mesh != none && zzampmesh != none)
		  	return "Altered Powerup Mesh Tweak" $ " (Details: Server's=" $ zzampmesh $ " , Player's=" $ zzAmp.Mesh $ ")";
   }
   foreach p.level.allactors(class'warheadlauncher', zzdeemer)
	{
   	if (zzdeemer.drawscale > zzDeemerDS && zzDeemerDS !=0) 
			return "Big Deemer Tweak" $ " (Details: Server's=" $ zzDeemerDS $ " , Player's=" $ zzdeemer.drawScale $ ")";
      else if (zzdeemer.Mesh != zzdeemermesh && zzdeemermesh != none && zzDeemer.Mesh != none && zzdeemer.Mesh != lodMesh'warhead') 
			return "Altered Powerup Mesh Tweak"  $ " (Details: Server's=" $ zzdeemermesh $ " , Player's=" $ zzdeemer.Mesh $ ")";
   }
   foreach p.level.allactors(class'healthPack', zzKeg)
	{
      if (zzKeg.drawscale > zzKegDS && zzKegDS !=0) 
			return "Big Keg Tweak" $ " (Details: Server's=" $ zzKegDS $ " , Player's=" $ zzKeg.drawScale $ ")";
      else if (zzKeg.Mesh != zzkegmesh && zzKeg.Mesh != none && zzkegmesh != none) 
			return "Altered Powerup Mesh Tweak"  $ " (Details: Server's=" $ zzkegmesh $ " , Player's=" $ zzkeg.mesh $ ")";
   }
   foreach p.level.allactors(class'ut_invisibility', zzinvis)
	{
      if (zzinvis.drawscale > zzinvisDS && zzinvisDS !=0) 
			return "Big Invis Tweak" $ " (Details: Server's=" $ zzinvisDS $ " , Player's=" $ zzinvis.drawScale $ ")";
      else if (zzinvis.Mesh != zzinvisMesh && zzinvis.Mesh != none && zzinvisMesh != none) 
			return "Altered Powerup Mesh Tweak" $ " (Details: Server's=" $ zzinvisMesh $ " , Player's=" $ zzinvis.Mesh $ ")";
   }
   foreach p.level.allactors(class'armor2', zzarmor)
	{
      if (zzarmor.drawscale > zzArmorDS && zzArmorDS !=0) 
			return "Big Armor Tweak" $ " (Details: Server's=" $ zzArmorDS $ " , Player's=" $ zzarmor.drawScale $ ")";
      else if (zzarmor.Mesh != zzarmorMesh && zzarmor.Mesh != none && zzarmorMesh != none) 
			return "Altered Armor Mesh Tweak" $ zzarmorMesh $ " , Player's=" $ zzarmor.Mesh $ ")";
   }
   foreach p.level.allactors(class'ut_jumpboots', zzboots)
	{
      if (zzboots.drawscale > zzBootsDS && zzBootsDS !=0) 
			return "Big Boots Tweak" $ " (Details: Server's=" $ zzBootsDS $ " , Player's=" $ zzboots.drawScale $ ")";
      else if (zzboots.Mesh != zzbootsMesh && zzboots.Mesh != none && zzbootsMesh != none) 
			return "Altered Boots Mesh Tweak" $ zzbootsMesh $ " , Player's=" $ zzboots.Mesh $ ")";
   }
   foreach p.level.allactors(class'ctfflag', zzflag)
	{
      if (zzflag.drawscale > zzflagDrawScale && zzflagDrawScale !=0) 
			return "Big Flags Tweak" $ " (Details: Server's=" $ zzflagDrawScale $ " , Player's=" $ zzFlag.drawScale $ ")";
      else if (zzflag.Mesh != zzflagMesh && zzflag.Mesh != none && zzflagMesh != none) 
			return "Altered Flag Mesh Tweak" $ " (Details: Server's=" $ zzflagMesh $ " , Player's=" $ zzFlag.Mesh $ ")";
      else if (zzflag.lightRadius != zzflagLtRad && !zzflag.bheld && zzflagLtRad != 0)
			return "Big Flag Glow Tweak" $ " (Details: Server's=" $ zzflagLtRad $ " , Player's=" $ zzflag.lightRadius $ ")";
   }
   foreach p.level.allactors(class'playerpawn', zzaplayer)
	{
      if (zzaplayer.lightRadius > 10)
			return "Big Player Glow Tweak" $ " (Details: Server's=" $ " , Player's=" $ zzaplayer.LightRadius $ ")";
   }
    
   if (class'UT_shieldBeltEffect'.default.lightType != zzSBEffectLightType && zzSBEffectLightType != 0)
		return "Shieldbelt Person Glow Tweak (Glow on a belted person which can be seen through walls. A Form of Radar.)";

   if (class'Translocatortarget'.default.lightBrightness != zzTransTargetLightBrightness)
		return "Translocator Glow (Large ring around trans; can be seen through walls) - A Form of Radar";
   else if (class'Translocatortarget'.default.soundradius != zzTransTargetSoundRadius && zzTransTargetSoundRadius != 0) 
		return "Translocator Sound Radius Tweak - Auditory Radar (Details: Server's=" $ zzTransTargetSoundRadius $ " , Player's=" $  class'Translocatortarget'.default.soundradius $ ")";

   if (class'enhancedRespawn'.default.lightRadius != zzenhancedRespawnLightRadius && zzenhancedRespawnLightRadius != 0)
		return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
   else if (class'enhancedRespawn'.default.lightEffect != zzEnhancedRespawnLightEffect && zzEnhancedRespawnLightEffect != 0)
		return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
   else if (class'enhancedRespawn'.default.lifeSpan != zzenhancedRespawnLifeSpan && zzenhancedRespawnLifeSpan != 0)
		return "Powerup Respawn Glow Tweak (Shows when powerups come up)";
   else if (class'enhancedRespawn'.default.DrawType != zzenhancedRespawnDrawType && zzenhancedRespawnDrawType != 0)
		return "Powerup Respawn Glow Tweak (Shows when powerups come up)";

   if (class'fire.watertexture'.default.bInvisible != zzbWaterInvis)
		return "No Water Tweak";
   else if (class'fire.wetTexture'.default.bInvisible != zzbFireWetTextureInvis)
		return "No Water Tweak";

   if (class'playerpawn'.default.bunlit != zzplayerBUnlit) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tmale1'.default.bunlit != zzplayerBUnlit) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tmale2'.default.bunlit != zzplayerBUnlit) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tfemale1'.default.bunlit != zzplayerBUnlit) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tfemale2'.default.bunlit != zzplayerBUnlit) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tournamentPlayer'.default.bunlit != zzplayerBUnlit)
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'BOT'.default.lighttype != LT_None)
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tfemale1'.default.Lighttype  != LT_None) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'tfemale2'.default.Lighttype  != LT_None) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'TMale1'.default.Lighttype  != LT_None) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";
   else if (class'TMale2'.default.Lighttype  != LT_None) 
		return "Bright Player Tweak (Makes players bright and unaffected by shadows)";

   if (class'translocouteffect'.default.texture == texture'botpack.womanbelt') 
		return "Transloc Person Outline Tweak";

   if (class'ShockBeam'.default.drawScale != zzShockBeamDS && zzShockBeamDS != 0) 
		return "Shockbeam Tweak - ((Details: Drawscale - Server's=" $ zzShockBeamDS $ " , Player's=" $ class'ShockBeam'.default.drawScale $ ")";
   else if (class'ShockBeam'.default.lifespan != zzShockBeamLifeSpan && zzShockBeamLifeSpan != 0) 
		return "Shockbeam Tweak - ((Details: Lifespan - Server's=" $ zzShockBeamLifeSpan $ " , Player's=" $ class'ShockBeam'.default.LifeSpan $ ")";
   else if (class'ShockBeam'.default.mesh != zzshockBeamMesh && zzshockBeamMesh != none)
		return "Shockbeam Tweak - Mesh Changed";

   if (class'pbolt'.default.mesh != zzPBoltMesh && zzPBoltMesh != none)
		return "Pulse Tweak - Mesh Changed";
   else if (class'starterBolt'.default.Mesh != zzStarterBoltMesh && zzStarterBoltMesh != none)
		return "Pulse Tweak - Mesh Changed";

   if (class'plasmahit'.default.texture != zzPlasmaHitTexture && zzPlasmaHitTexture != none)
		return "Pulse tweak - Texture Changed To Indicate Hit";

   if (class'pbolt'.default.DrawScale != zzPBoltDS && zzPBoltDS != 0) 
		return "Pulse Tweak - Pbolt changed ((Details: DrawScale - Server's=" $ zzPBoltDS $ " , Player's=" $ class'pbolt'.default.drawScale $ ")";
   else if (class'starterbolt'.default.DrawScale != zzstarterBoltDS && zzstarterBoltDS != 0) 
		return "Pulse Tweak - Starterbolt changed ((Details: DrawScale - Server's=" $ zzstarterBoltDS $ " , Player's=" $ class'starterBolt'.default.drawScale $ ")";

   if (class'ut_spriteSmokePuff'.default.bHidden != zzbRocketPuffHidden)
		return "No Smoke Tweak";
   else if (class'LightSmokeTrail'.default.bHidden != zzbRocketTrailHidden)
		return "No Smoke Tweak";
   else if (class'utSmokeTrail'.default.bHidden != zzbUtSmokeTrail)
		return "No Smoke Tweak";
   else if (class'utSmokeTrail'.default.drawScale != zzUTSmokeTrailDS && zzUTSmokeTrailDS != 0) 
		return "No Smoke Tweak - ((Details: Server's=" $ zzUTSmokeTrailDS $ " , Player's=" $ class'utSmokeTrail'.default.drawScale $ ")";

   return "";
}

simulated function broadcast(string s)
{
	p.consolecommand("mutate AntiCheat broadcast " $ s);
}

defaultproperties
{
   bAlwaysRelevant=True
   RemoteRole=ROLE_SimulatedProxy
   bNetInitial=True
}
