
class KBLogger extends Mutator config(CAC);

var bool zzbInitialised;
var string Players[32];
var int k;
var config string SkipMenu[255];
var config string SkipKeyBind[255];


function PreBeginPlay ()
{
   Super.PreBeginPlay();
   SetTimer(1.0,True);
}

function PostBeginPlay()
{
   if (!zzbInitialised)
   {
      zzbInitialised = True;
      Level.Game.RegisterMessageMutator(Self);
      log("*    CombinedAC: Keybind/ModMenu logger is active    *");
   }
}

function Timer()
{
   local Pawn zzP;
   local int zzi;
   local bool zzbChecked;
   local CACInfo zza;

   for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
   {
      if (zzP.IsA('PlayerPawn'))
      {
	 		for (zzi=0; zzi<32; zzi++)
         {
	    		if (zzP.PlayerReplicationInfo.PlayerName == Players[zzi])
            {
	       		zzbChecked = True;
	       		break;
	    		}
	 		}
	 		if (!zzbChecked)
         {
	    		zza = Spawn(class'CACInfo',zzp,,zzp.Location);
            if (zza != None)
				{
               zza.xxGetKeyBinds(k);
               zza.xxGetModMenus(k);
					xxSkipPlayers(PlayerPawn(zzP));
				}
         }
         zzbChecked = False;
      }
   }
}

function xxSkipPlayers(PlayerPawn P)
{
   local int zzi;

   for (zzi=0; zzi<32; zzi++)
   {
      if (Players[zzi] == "")
      {
         Players[zzi] = P.PlayerReplicationInfo.PlayerName;
         zzi = 500;
      }
   }
}

function Mutate(string MutateString, PlayerPawn Sender)
{
   local string sArgument;
   local int iPlayerID;
   local int i;
   local int i1, i2;
   local Pawn p;
   local string sMode;
   local CACInfo a;

   if (Left(Caps(MutateString),3) == "TP ")
   {	// Parse mutatestring
   	sArgument = Mid(MutateString, 3);
      // Info recieved from clients
      if (Left(Caps(sArgument), 5) == "TPKB ")
      {
	 		sMode = Left(Caps(sArgument), 4);
	 		if (sMode == "TPKB")
	    		sMode = "KeyBind";

         sArgument = Mid(sArgument, 5);
         i1 = InStr(sArgument, " ");
         if (i1>0)
	    		i2 = InStr(Mid(sArgument, i1+1), " ");

	 		if ((i1>0) && (i2>0))
	 		{
            iPlayerID = int(Mid(sArgument, i1+1, i2));
	    		sArgument = Mid(sArgument, i1+i2+2);
	    		//if (sMode == "KeyBind")
	    		if ((sMode == "KeyBind") && (!IsItemInKeyBindList(Caps(sArgument))))
	       		p = xxGetPawnByPlayerID(iPlayerID);
	    		if (p != None)
	       		Log("*    CombinedAC: " $ sArgument $ "[" $ sMode $ "][" $ p.PlayerReplicationInfo.PlayerName $ "]");
         }
      }
      if (Left(Caps(sArgument), 5) == "TPMM ")
      {
         sMode = Left(Caps(sArgument), 4);
         if (sMode == "TPMM")
	    		sMode = "ModMenu";

         sArgument = Mid(sArgument, 5);
         i1 = InStr(sArgument, " ");
	 		if (i1>0)
	    		i2 = InStr(Mid(sArgument, i1+1), " ");

	 		if ((i1>0) && (i2>0))
	 		{
	    		iPlayerID = int(Mid(sArgument, i1+1, i2));
	    		sArgument = Mid(sArgument, i1+i2+2);

	    		//if (sMode == "ModMenu")
	    		if ((sMode == "ModMenu") && (!IsItemInMenuList(Caps(sArgument))))
	       		p = xxGetPawnByPlayerID(iPlayerID);

            if (p !=none)
	       		Log("*    CombinedAC: " $ sArgument $ "[" $ sMode $ "][" $ p.PlayerReplicationInfo.PlayerName $ "]");

	 		}
      }
   }
   else if (NextMutator != None)
      NextMutator.Mutate(MutateString, Sender);
}

function Pawn xxGetPawnByPlayerID(int iPlayerID)
{
   local Pawn zzp;

   for (zzp=Level.PawnList; zzp!=None; zzp=zzp.NextPawn)
      if ((zzp.bIsPlayer) && (zzp.PlayerReplicationInfo != None) && (zzp.PlayerReplicationInfo.PlayerID == iPlayerID))
	 		return (zzp);
   return (None);
}

function bool IsItemInMenuList(string sName)
{
	local int i;

	if (InStr(sName, ".") > 0)
		sName=Left(sName, InStr(sName, "."));

	for(i=0; i<255 && SkipMenu[i] != ""; i++)
		if (SkipMenu[i] == sName)
			return (true);
	return (false);
}

function bool IsItemInKeyBindList(string sName)
{
	local int i;

	if (InStr(sName, " ") > 0)
		sName=Left(sName, InStr(sName, " "));

	for(i=0; i<255 && SkipKeyBind[i] != ""; i++)
		if (SkipKeyBind[i] == sName)
			return (true);
	return (false);
}

defaultproperties
{
}
